# Fall 2021 Q4
# Question by Fall 2021 course staff

def reshape(table, r, c):
    """Returns a copy of `table` reshaped to have r rows and c cols.

    Example: reshape([[0,1,2],[3,4,5]],3,2) returns [[0,1],[2,3],[4,5]]

    Precondition: table is a nonempty 2d list of numbers. r and c are ints with 
    r*c equal to the total number of elements in the table."""
    pass
    
    # Flatten the table into a 1-d list
    flat = []
    for row in table:
        flat += row

    out = []
    for row_num in range(r):
        out.append(flat[:c])
        flat = flat[c:]
    return out

# TESTING CODE


testcases = [
    [ [[0,1,2],[3,4,5]],    # table
       3,                   # r 
       2,                   # c
       [[0,1],[2,3],[4,5]]  # expected
    ],
    [ [[1, 2, 3, 4], [5, 6, 7, 8]],
      4,
      2,
      [[1, 2], [3, 4], [5, 6], [7, 8]]
    ],
    [ [[1, 2], [3, 4], [5, 6], [7, 8]],
      1,
      8,
      [[1, 2, 3, 4, 5, 6, 7, 8]]
    ]
]

for tc in testcases:
    table = tc[0]
    r = tc[1]
    c = tc[2]
    expected = tc[3]


    print("testing with table "+repr(table))
    result = reshape(table, r, c)
    assert_msg = "result should be "+repr(expected)+" but is "+repr(result)
    assert result == expected, assert_msg
    
print("Ran through testcases without crashing! What a relief!")

